/* FOFL test file.  Process with -i argument to ignore errors.
   Every program here should generate an error. 
*/

/* Evaluating untypable terms */

succ false !:;


/* Typing errors */

prog
   def f(x:Nat):Bool = succ x   /* mismatched body */
gorp

prog
   def f(x:Nat):Bool = succ (succ x)   /* mismatched body */
gorp

prog
   def f(x:Nat):Bool = f(f(x))   /* mismatched application */
gorp

prog
   def f(x:Bool,z:Nat):Bool = f(z,x)   /* mismatched application */
gorp



/* Errors violating naming conventions */

prog
    def f1(x:Nat):Nat = f1()          /* too few arguments */
gorp

prog
    def f2(x:Nat,z:Nat):Nat = f2(x)   /* too few arguments */
gorp

prog
    def f3(x:Nat):Nat = f3(x,x,x)     /* too many arguments */
gorp

prog
    def g1(x:Nat,x:Nat):Nat = x      /* repeated variables */
gorp

prog
    def g2(x:Nat,z:Bool,x:Bool):Nat = x    /* repeated variables */
gorp

prog
   def h1(x:Nat):Nat = x        /* repeated definition */
   def h2(z:Bool):Bool = z
   def h1(x:Nat):Nat = x
gorp

prog
   def h3(x:Nat):Nat = z  /* unbound identifier */
gorp
